<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryRef" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="项目名称" prop="projectName">
        <el-input
          v-model="queryParams.projectName"
          placeholder="请输入项目名称"
          clearable
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
        <el-button icon="Refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="Plus"
          @click="handleAdd"
          v-hasPermi="['manage:proProjectInfoSetting:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="Edit"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['manage:proProjectInfoSetting:edit']"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="Delete"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['manage:proProjectInfoSetting:remove']"
        >删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="Download"
          @click="handleExport"
          v-hasPermi="['manage:proProjectInfoSetting:export']"
        >导出</el-button>
      </el-col>
      <right-toolbar v-model:showSearch="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="proProjectInfoSettingList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="主键" align="center" prop="id" />
      <el-table-column label="项目主键" align="center" prop="projectId" />
      <el-table-column label="显示名称" align="center" prop="orgName" />
      <el-table-column label="显示LOGO" align="center" prop="orgLogo" />
      <el-table-column label="项目图片" align="center" prop="orgImage" width="100">
        <template #default="scope">
          <image-preview :src="scope.row.orgImage" :width="50" :height="50"/>
        </template>
      </el-table-column>
      <el-table-column label="项目视频" align="center" prop="orgVideo" />
      <el-table-column label="项目平面图" align="center" prop="orgPlane" width="100">
        <template #default="scope">
          <image-preview :src="scope.row.orgPlane" :width="50" :height="50"/>
        </template>
      </el-table-column>
      <el-table-column label="删除标识" align="center" prop="isDel">
        <template #default="scope">
          <dict-tag :options="sys_is_del" :value="scope.row.isDel"/>
        </template>
      </el-table-column>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template #default="scope">
          <el-button link type="primary" icon="Edit" @click="handleUpdate(scope.row)" v-hasPermi="['manage:proProjectInfoSetting:edit']">修改</el-button>
          <el-button link type="primary" icon="Delete" @click="handleDelete(scope.row)" v-hasPermi="['manage:proProjectInfoSetting:remove']">删除</el-button>
        </template>
      </el-table-column>
    </el-table>
    
    <pagination
      v-show="total>0"
      :total="total"
      v-model:page="queryParams.pageNum"
      v-model:limit="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改项目设置对话框 -->
    <el-dialog :title="title" v-model="open" width="500px" append-to-body>
      <el-form ref="proProjectInfoSettingRef" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="项目主键" prop="projectId">
          <el-input v-model="form.projectId" placeholder="请输入项目主键" />
        </el-form-item>
        <el-form-item label="显示名称" prop="orgName">
          <el-input v-model="form.orgName" placeholder="请输入显示名称" />
        </el-form-item>
        <el-form-item label="显示LOGO" prop="orgLogo">
          <el-input v-model="form.orgLogo" placeholder="请输入显示LOGO" />
        </el-form-item>
        <el-form-item label="项目图片" prop="orgImage">
          <image-upload v-model="form.orgImage"/>
        </el-form-item>
        <el-form-item label="项目视频" prop="orgVideo">
          <file-upload v-model="form.orgVideo"/>
        </el-form-item>
        <el-form-item label="项目平面图" prop="orgPlane">
          <image-upload v-model="form.orgPlane"/>
        </el-form-item>
        <el-form-item label="删除标识" prop="isDel">
          <el-select v-model="form.isDel" placeholder="请选择删除标识">
            <el-option
              v-for="dict in sys_is_del"
              :key="dict.value"
              :label="dict.label"
              :value="parseInt(dict.value)"
            ></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="备注" prop="remark">
          <el-input v-model="form.remark" placeholder="请输入备注" />
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="ProProjectInfoSetting">
import { listProProjectInfoSetting, getProProjectInfoSetting, delProProjectInfoSetting, addProProjectInfoSetting, updateProProjectInfoSetting } from "@/api/manage/proProjectInfoSetting";

const { proxy } = getCurrentInstance();
const { sys_is_del } = proxy.useDict('sys_is_del');

const proProjectInfoSettingList = ref([]);
const open = ref(false);
const loading = ref(true);
const showSearch = ref(true);
const ids = ref([]);
const single = ref(true);
const multiple = ref(true);
const total = ref(0);
const title = ref("");

const data = reactive({
  form: {},
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    projectName: null,
  },
  rules: {
  }
});

const { queryParams, form, rules } = toRefs(data);

/** 查询项目设置列表 */
function getList() {
  loading.value = true;
  listProProjectInfoSetting(queryParams.value).then(response => {
    proProjectInfoSettingList.value = response.rows;
    total.value = response.total;
    loading.value = false;
  });
}

// 取消按钮
function cancel() {
  open.value = false;
  reset();
}

// 表单重置
function reset() {
  form.value = {
    id: null,
    projectId: null,
    orgName: null,
    orgLogo: null,
    orgImage: null,
    orgVideo: null,
    orgPlane: null,
    isDel: null,
    createBy: null,
    createTime: null,
    updateBy: null,
    updateTime: null,
    remark: null
  };
  proxy.resetForm("proProjectInfoSettingRef");
}

/** 搜索按钮操作 */
function handleQuery() {
  queryParams.value.pageNum = 1;
  getList();
}

/** 重置按钮操作 */
function resetQuery() {
  proxy.resetForm("queryRef");
  handleQuery();
}

// 多选框选中数据
function handleSelectionChange(selection) {
  ids.value = selection.map(item => item.id);
  single.value = selection.length != 1;
  multiple.value = !selection.length;
}

/** 新增按钮操作 */
function handleAdd() {
  reset();
  open.value = true;
  title.value = "添加项目设置";
}

/** 修改按钮操作 */
function handleUpdate(row) {
  reset();
  const _id = row.id || ids.value
  getProProjectInfoSetting(_id).then(response => {
    form.value = response.data;
    open.value = true;
    title.value = "修改项目设置";
  });
}

/** 提交按钮 */
function submitForm() {
  proxy.$refs["proProjectInfoSettingRef"].validate(valid => {
    if (valid) {
      if (form.value.id != null) {
        updateProProjectInfoSetting(form.value).then(response => {
          proxy.$modal.msgSuccess("修改成功");
          open.value = false;
          getList();
        });
      } else {
        addProProjectInfoSetting(form.value).then(response => {
          proxy.$modal.msgSuccess("新增成功");
          open.value = false;
          getList();
        });
      }
    }
  });
}

/** 删除按钮操作 */
function handleDelete(row) {
  const _ids = row.id || ids.value;
  proxy.$modal.confirm('是否确认删除项目设置编号为"' + _ids + '"的数据项？').then(function() {
    return delProProjectInfoSetting(_ids);
  }).then(() => {
    getList();
    proxy.$modal.msgSuccess("删除成功");
  }).catch(() => {});
}

/** 导出按钮操作 */
function handleExport() {
  proxy.download('manage/proProjectInfoSetting/export', {
    ...queryParams.value
  }, `proProjectInfoSetting_${new Date().getTime()}.xlsx`)
}

getList();
</script>
